/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.*;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import synthesisclient.SynthesisClient;

/**
 *
 * @author Trond
 */
@WebServlet(name = "NoraServlet", urlPatterns = {"/NoraServlet"})
public class NoraServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            /*
             * TODO output your page here. You may use following sample code.
             */
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet NoraServlet</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet NoraServlet at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        } finally {            
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
        
        String filePath = "/home/trondboe/audio/nora_alaw.wav";
        
        System.out.println("HOUSTON, we have GET contact!");
        String text = request.getParameter("text").toString();
        System.out.println("Text: "+text);
        
        System.out.println("Initiating audio tools...");
        SynthesisClient sc = new SynthesisClient();
        String outputFilePath = sc.run(text, filePath);
        System.out.println("OUTPUTFILEPATH2: "+outputFilePath);
  
        //Send file back home
        if(outputFilePath == null || outputFilePath.trim().equals("")){
            System.out.println("ERROR: Cannot playback file. Missing?");
            return;
        }
        FileInputStream fis = new FileInputStream(outputFilePath);
        
        //Read from inputstream
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        int nRead;
        byte[] data = new byte[16384];
        while ((nRead = fis.read(data, 0, data.length)) != -1) {
            baos.write(data, 0, nRead);
        }
        baos.flush();           
        byte[] buffer = baos.toByteArray();
        
        //Write to response
        response.getOutputStream().write(buffer);
        response.getOutputStream().flush();
        response.getOutputStream().close();
        System.out.println("File written and sent (Hopefully)");
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
        System.out.println("HOUSTON, we have POST contact!");
        String text = request.getParameter("text").toString();
        System.out.println("Text: "+text);
       /* String firstName = request.getParameter("firstName").toString();
        String surname = request.getParameter("surname").toString();
        System.out.println("Ditt navn er "+firstName+" "+surname+".");*/
        
        /*System.out.println("Initiating audio tools...");
        SynthesisClient sc = new SynthesisClient();
        sc.run(text, "/home/trondboe/audio/nora_alaw.wav");*/
        
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
