/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package synthesisclient;

import java.io.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

/**
 *
 * @author Trond
 */
public class Zip {
   static final int BUFFER = 2048;
   public static boolean compress(String inputFilePath) {
      try {
         BufferedInputStream origin = null;
         String outputFilePath = inputFilePath.substring(0, inputFilePath.length()-3)+"zip";
         //System.out.println(outputFilePath);
         FileOutputStream dest = new 
           FileOutputStream(outputFilePath);
         ZipOutputStream out = new ZipOutputStream(new 
           BufferedOutputStream(dest));
         //out.setMethod(ZipOutputStream.DEFLATED);
         byte data[] = new byte[BUFFER];
         // get a list of files from current directory
         //File f = new File(".");
         //String files[] = f.list();

         /*for (int i=0; i<files.length; i++) {
            System.out.println("Adding: "+files[i]);
            FileInputStream fi = new 
              FileInputStream(files[i]);
            origin = new 
              BufferedInputStream(fi, BUFFER);
            ZipEntry entry = new ZipEntry(files[i]);
            out.putNextEntry(entry);
            int count;
            while((count = origin.read(data, 0, 
              BUFFER)) != -1) {
               out.write(data, 0, count);
            }
            origin.close();
         }*/
         
        FileInputStream fi = new FileInputStream(inputFilePath);
        origin = new BufferedInputStream(fi, BUFFER);
        ZipEntry entry = new ZipEntry(inputFilePath);
        out.putNextEntry(entry);
        int count;
        while((count = origin.read(data, 0, 
            BUFFER)) != -1) {
            out.write(data, 0, count);
        }
        origin.close();
         
         
         out.close();
      } catch(Exception e) {
         e.printStackTrace();
         return false;
      }
      return true;
   }


    public static boolean extract(String inputFilePath) {
        final int BUFFER = 2048;

        try {
            BufferedOutputStream dest = null;
            FileInputStream fis = new 
            FileInputStream(inputFilePath);
            ZipInputStream zis = new ZipInputStream(new BufferedInputStream(fis));
            ZipEntry entry;
            while((entry = zis.getNextEntry()) != null) {
                System.out.println("Extracting: " +entry);
                int count;
                byte data[] = new byte[BUFFER];
                // write the files to the disk
                FileOutputStream fos = new 
                    FileOutputStream(entry.getName());
                dest = new 
                    BufferedOutputStream(fos, BUFFER);
                while ((count = zis.read(data, 0, BUFFER)) 
                    != -1) {
                    dest.write(data, 0, count);
                }
                dest.flush();
                dest.close();
            }
            zis.close();
        } catch(Exception e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
}
