package org.synthesis.gui;

public class AppInfo
{
    /**
     * The login parameters should be specified in the following manner:
     * 
     * public static final String SpeechKitServer = "ndev.server.name";
     * 
     * public static final int SpeechKitPort = 1000;
     * 
     * public static final String SpeechKitAppId = "ExampleSpeechKitSampleID";
     * 
     * public static final byte[] SpeechKitApplicationKey =
     * {
     *     (byte)0x38, (byte)0x32, (byte)0x0e, (byte)0x46, (byte)0x4e, (byte)0x46, (byte)0x12, (byte)0x5c, (byte)0x50, (byte)0x1d,
     *     (byte)0x4a, (byte)0x39, (byte)0x4f, (byte)0x12, (byte)0x48, (byte)0x53, (byte)0x3e, (byte)0x5b, (byte)0x31, (byte)0x22,
     *     (byte)0x5d, (byte)0x4b, (byte)0x22, (byte)0x09, (byte)0x13, (byte)0x46, (byte)0x61, (byte)0x19, (byte)0x1f, (byte)0x2d,
     *     (byte)0x13, (byte)0x47, (byte)0x3d, (byte)0x58, (byte)0x30, (byte)0x29, (byte)0x56, (byte)0x04, (byte)0x20, (byte)0x33,
     *     (byte)0x27, (byte)0x0f, (byte)0x57, (byte)0x45, (byte)0x61, (byte)0x5f, (byte)0x25, (byte)0x0d, (byte)0x48, (byte)0x21,
     *     (byte)0x2a, (byte)0x62, (byte)0x46, (byte)0x64, (byte)0x54, (byte)0x4a, (byte)0x10, (byte)0x36, (byte)0x4f, (byte)0x64
     * };
     * 
     * Please note that all the specified values are non-functional
     * and are provided solely as an illustrative example.
     * 
     */

    /* Please contact Nuance to receive the necessary connection and login parameters */
    public static final String SpeechKitServer = "sandbox.nmdp.nuancemobility.net";

    public static final int SpeechKitPort = 443;
    
    public static final boolean SpeechKitSsl = false;

    public static final String SpeechKitAppId = "NMDPTRIAL_rastaflettus20120416061032";
    
    public static final byte[] SpeechKitApplicationKey = {(byte)0xf8, (byte)0x12, (byte)0xfc, (byte)0xee, (byte)0xc8, (byte)0x2c, (byte)0x41, (byte)0x9c, (byte)0x97, (byte)0x94, (byte)0x79, (byte)0x21, (byte)0xec, (byte)0x92, (byte)0xca, (byte)0x9d, (byte)0xff, (byte)0x9c, (byte)0x2a, (byte)0x3f, (byte)0x41, (byte)0xd2, (byte)0xd9, (byte)0x84, (byte)0x74, (byte)0x07, (byte)0x41, (byte)0x20, (byte)0x7f, (byte)0xf4, (byte)0x56, (byte)0x77, (byte)0x06, (byte)0x52, (byte)0x65, (byte)0xce, (byte)0x7f, (byte)0xa7, (byte)0x6a, (byte)0x16, (byte)0x3b, (byte)0xe3, (byte)0x37, (byte)0x27, (byte)0x75, (byte)0x01, (byte)0xc4, (byte)0x74, (byte)0x9e, (byte)0xee, (byte)0xb4, (byte)0xdf, (byte)0xc0, (byte)0x8d, (byte)0x63, (byte)0x34, (byte)0x94, (byte)0xa5, (byte)0x55, (byte)0x13, (byte)0x99, (byte)0xab, (byte)0x8a, (byte)0x9f};
}
