package org.synthesis.gui;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;


public class MainActivity extends Activity {

	private static final String TAG = "SynthesisTest";
	private Context _context;



	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		_context = this.getApplicationContext();
		
		setContentView(R.layout.main);

		//Intent myIntent = new Intent(_context, TTSActivity.class);
	//	startActivity(myIntent);

		findViewById(R.id.tts).setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				Intent myIntent = new Intent(_context, TTSActivity.class);
				startActivity(myIntent);
			}
		});


		findViewById(R.id.test).setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				Intent myIntent = new Intent(_context, TestActivity.class);
				startActivity(myIntent);
			}
		});
	}

}